﻿SuperStrict

Framework brl.basic
Import brl.d3d7max2d
Import brl.filesystem
Import brl.textstream
Import brl.freetypefont
Import brl.retro

ChangeDir(CurrentDir())

AppTitle = "ptzm v1.1"
Graphics(600, 600)

Global frazeCount:Int = 14
Local breakPos:Int[] = [2, 6, 10]
Local fntSize:Int = 26

If(FileType("data\info.txt") = 1)
	Local text:String = LoadText("data\info.txt")
	Local mas:String[] = text.Split("~r~n")
	frazeCount = Int(mas[0])
	Local k:Int, cnt:Int = Int(mas[1])
	breakPos = New Int[cnt]
	For k = 0 Until cnt
		breakPos[k] = Int(mas[2 + k])
	Next
EndIf
Global frazes:String[][] = New String[][frazeCount]
Local drawFrazes:String[] = New String[frazeCount]

LoadFrazes()

Local f1:TImageFont = LoadImageFont("data\font.ttf", fntSize)
Local f2:TImageFont = LoadImageFont("data\font.ttf", 16)

Local k:Int, j:Int, break:Int
Local x:Float, y:Float, x0:Float
Local s:String, full:String = "", save:Int, path:String = ""

SeedRnd(MilliSecs())

GetRandomFrazes(drawFrazes, False)

While Not(KeyHit(KEY_ESCAPE) Or AppTerminate())
	x0 = 40
	x = x0
	y = 50
	save = KeyHit(KEY_F2) Or MouseHit(2)
	If(KeyHit(KEY_SPACE) Or MouseHit(1))
		GetRandomFrazes(drawFrazes) 'используется ссылка, Var
	EndIf
	SetImageFont(f1)
	SetColor(200, 200, 200)
	For k = 0 Until frazeCount
		If(drawFrazes[k] = Null) Then Continue
		x = x + DrawFraze(drawFrazes[k], x, y)
		If(save = True) Then full:+drawFrazes[k] + " "
		break = False
		For j = 0 Until breakPos.Length
			If(k = breakPos[j])
				break = True
				Exit
			EndIf
		Next
		If(break = True)
			If(x0 < 50)
				x0:+20
			Else
				x0:-20
			EndIf
			x = x0
			y:+40
			If(save = True) Then full:+"~r~n"
		EndIf
	Next
	SetImageFont(f2)
	SetColor(130, 130, 130)
	DrawText("Пробел, ЛКМ - генерить новое", 20, 540)
	DrawText("F2, ПКМ - сохранить", 20, 560)
	If(path <> "") Then DrawText("Сохранено: " + path, 250, 560)
	Flip
	Cls
	If(save = True)
		CreateDir("save")
		path = "save\" + CurrentDate() + ", " + CurrentTime() + ".txt"
		path = path.Replace(":", " ")
		SaveText(full, path)
		full = ""
	EndIf
Wend

End

Function GetRandomFrazes(mas:String[] Var, random:Int = True)
	If(Rand(100) > 50) Then SeedRnd(Rand(0, 100000000)) 'улучшение рандома?
	For Local k:Int = 0 Until frazeCount
		If(random = True)
			mas[k] = frazes[k][Rand(0, frazes[k].Length - 1)]
		Else
			mas[k] = frazes[k][0]
		EndIf
	Next
End Function

Function DrawFraze:Float(fraze:String, x:Float, y:Float)
	fraze:+" "
	DrawText(fraze, x, y)
	Return TextWidth(fraze)
End Function

Function LoadFrazes()
	Local k:Int, text:String, path:String
	For k = 0 Until frazeCount
		path = "data\" + k + ".txt"
		If(FileType(path) <> 1) Then Continue  'RuntimeError("Файл " + path + " не найден. Выход из программы.")
		text = Trim(LoadText(path))
		frazes[k] = text.Split("~r~n")
	Next
End Function